seo:
  title: The ultimate guide to GitOps with GitLab
  description: >-
    This eight-part tutorial series demonstrates how to use GitLab as a
    best-in-class GitOps tool.
  ogTitle: The ultimate guide to GitOps with GitLab
  ogDescription: >-
    This eight-part tutorial series demonstrates how to use GitLab as a
    best-in-class GitOps tool.
  noIndex: false
  ogImage: images/blog/hero-images/GitLab-Ops.png
  ogUrl: https://about.gitlab.com/blog/the-ultimate-guide-to-gitops-with-gitlab
  ogSiteName: https://about.gitlab.com
  ogType: article
  canonicalUrls: https://about.gitlab.com/blog/the-ultimate-guide-to-gitops-with-gitlab
  schema: |2-

                            {
            "@context": "https://schema.org",
            "@type": "Article",
            "headline": "The ultimate guide to GitOps with GitLab",
            "author": [{"@type":"Person","name":"Viktor Nagy"}],
            "datePublished": "2022-04-07",
          }

content:
  title: The ultimate guide to GitOps with GitLab
  description: >-
    This eight-part tutorial series demonstrates how to use GitLab as a
    best-in-class GitOps tool.
  authors:
    - Viktor Nagy
  heroImage: images/blog/hero-images/GitLab-Ops.png
  date: '2022-04-07'
  body: >+


    It is possible to use GitLab as a best-in-class GitOps tool, and this blog
    post series is going to show you how. [GitOps](/topics/gitops/) is an
    operational framework that takes DevOps best practices used for application
    development such as version control, collaboration, compliance, and CI/CD
    tooling, and applies them to infrastructure automation. This series of
    easy-to-follow tutorials will focus on different user problems, including
    provisioning, managing a base infrastructure, and deploying various
    third-party or custom applications on top of them, that can be solved by
    pairing GitOps with GitLab.


    Here are 8 tutorials on how to do GitOps with GitLab:


    **1. [Here's how to do GitOps with
    GitLab](/blog/2021/10/21/gitops-with-gitlab/)**


    This tutorial sets the stage for what you will learn throughout the series,
    including the tech concepts you'll need to know.


    **2. [Infrastructure provisioning with GitLab and
    Terraform](/blog/2021/11/04/gitops-with-gitlab-infrastructure-provisioning/)**


    This tutorial walks you through setting up the underlying infrastructure
    using GitLab and Terraform.


    **3. [Connect with a Kubernetes
    cluster](/blog/2021/11/18/gitops-with-gitlab-connecting-the-cluster/)**


    This tutorial demonstrates how to connect a Kubernetes cluster with GitLab
    for pull- and push-based deployments and easy security integrations.


    **4. [How to tackle secrets
    management](/blog/2021/12/02/gitops-with-gitlab-secrets-management/)**


    This tutorial builds on the previous tutorial to show you how to use a
    Kubernetes cluster connection to manage secrets within a cluster.


    **5. [The CI/CD tunnel](/blog/2022/01/07/gitops-with-gitlab-using-ci-cd/)**


    This tutorial introduces you to CI/CD tunnels and shows step-by-step how to
    access a Kubernetes cluster using GitLab CI/CD.


    **6. [Connecting GitLab with a Kubernetes cluster - Auto
    DevOps](/blog/2022/02/08/gitops-with-gitlab-auto-devops/)**


    This tutorial looks at how you can use Auto DevOps with all its bells and
    whistles to easily manage deployments.


    **7. [Connecting GitLab with a Kubernetes cluster for GitOps-style
    application delivery](/blog/2022/03/21/gitops-with-gitlab/)**


    This tutorial shows you how to connect an application project to a manifest
    project for controlled, GitOps-style deployments.


    **8. [Turn a GitLab agent for Kubernetes installation to manage
    itself](/blog/2022/03/30/gitops-with-gitlab-manage-the-agent/)**


    This tutorial is the culmination of the previous tutorials and will teach
    you how to turn a GitLab agent for Kubernetes installation to manage itself.



    **Read more about GitOps:**

    - [GitLab for GitOps](/solutions/gitops/)

    - [What is GitOps](/topics/gitops/)

    - [GitOps viewed as part of the Ops
    evolution](/blog/2021/07/12/gitops-as-the-evolution-of-operations/)

    - [How to use a push-based approach for GitOps with GitLab scripting and
    variables](/blog/2021/07/23/how-to-agentless-gitops-vars/)




  category: Engineering
  tags:
    - DevOps
    - tutorial
    - GitOps
config:
  slug: the-ultimate-guide-to-gitops-with-gitlab
  featured: false
  template: BlogPost
